// http://code.google.com/apis/language/translate/v2/getting_started.html
// http://howtonode.org/how-to-module
// https://github.com/jimmycuadra/to_lang/tree/master/lib
// http://rubydoc.info/github/jimmycuadra/to_lang/master/frames
// http://rubydoc.info/github/jimmycuadra/to_lang/master/ToLang
// https://github.com/dresende/node-string/blob/master/lib/string.js

var https = require('https'),
    querystring = require('querystring');

var ToLang = function() {
  var key = '';
  var source = '';
};

ToLang.prototype.getTranslation = function(q, cb) {
  var path = "/language/translate/v2?key="+t.key+"&"+q;
    
  var options = {
    host: 'www.googleapis.com',
	path: path
  };
  
  https.get(options, function(res) {	
	res.on('data', function(d) {
	  //process.stdout.write(d);
	  var j = JSON.parse(d);
	  cb(j.error, j);
	});
  }).on('error', function(e) {
    console.log(e);
  });
};

ToLang.prototype.translate = function(q, source, target, cb) {
  var parameters = {
    q: q,
	source: source,
	target: target || 'en'
  };  
  
  if (parameters.source == 'auto')
    delete parameters.source;
  
  var query = querystring.stringify(parameters);
  
  return t.getTranslation(query, cb);
};

ToLang.prototype.setSource = function(source) {
  t.source = source;
};

var t
exports.start = function(key, source) {
  t = new ToLang();
  t.key = key;
  t.source = source || 'auto';
   
  var languages = require('./languages').languages;
  createFunctions(languages);

  return t;
};


String.prototype.to = function(target, callback) {
  this.translate(t.source, target, callback);
};

String.prototype.translate = function(source, target, callback) {
  t.translate(this.valueOf(), source, target, function(err, j) {
    if (err){
	  console.log('source: '+source+' target: '+target);
	  console.log(err);
	  throw new Error(err.message);
	}
	return callback(j.data.translations[0].translatedText);
  });
};

var createFunctions = function(langs){
  var func = '';
  for (i in langs){
    //  eval func string laid out for readability
    // String.prototype.to_en = function(callback) {
    //   this.translate('auto', 'en', callback);
    // };
	
    func = "String.prototype.to_"+langs[i]+" = function(callback) {this.translate('auto', '"+langs[i]+"', callback);};";
	eval(func);  // create .to_xx methods
	func = "String.prototype.to_"+i+" = function(callback){this.translate('auto', '"+langs[i]+"', callback);};";
	eval(func);  // create .to_[language] methods
	for (j in langs){
	  func = "String.prototype.to_"+langs[i]+"_from_"+langs[j]+" = function(callback) {this.translate('"+langs[j]+"', '"+langs[i]+"', callback);};";
	  eval(func); // create .to_xx_from_yy methods
	  func = "String.prototype.to_"+i+"_from_"+j+" = function(callback) {this.translate('"+langs[j]+"', '"+langs[i]+"', callback);};";
	  eval(func); // create .to_[languageX]_from_[languageY] methods
	}
  }
};

